
// diStorm library sample
// http://ragestorm.net/distorm
// Arkon, 2005

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "distorm.h"

// Link the library into our project.
#pragma comment(lib, "distorm.lib")

int main()
{
	// Buffer to disassemble.
	char buf[] = "\xB9\x05\x00\xB0\x30\xCD\x29\xFE\xC0\xE2\xFA\xC3";

	// Head node, this will hold the returned list.
	_DINode* head;
	// Holds the result of the decoding.
	_DecodeResult res;
	// Decoded instruction information.
	_DecodedInst* di;

	// Decode the buffer at offset 0x100 in 16 bits.
	res = distorm_decode(&head, 0x100, buf, sizeof(buf)-1, Decode16Bits);
	if (res == DECRES_INPUTERR) {
		// Null buffer? Decode type not 16/32?
		printf("Input error, halting!");
		return -1;
	} else if (res == DECRES_MEMORYERR) {
		printf("Not enough memory!\r\n");
		// There might be some data in the linked list, so scan it anyways.
	}

	// As long as there are instructions in the list to read,
	while (di = ll_get(&head)) {
		// Output them in this format:
		printf("0x%08x (%02x) %-20s '%s%s%s'\r\n", di->offset, di->size, (char*)di->instructionHex.p, (char*)di->mnemonic.p, di->operands.length != 0 ? " " : "", (char*)di->operands.p);
	}

	return 0;
}